#ifndef MOG2_VALUE_SCRIPTS
#define MOG2_VALUE_SCRIPTS

#define VALUE_CMD_INTEGER		0
#define VALUE_CMD_STRING		1
#define VALUE_CMD_KEY			2
#define VALUE_CMD_VARIABLE		3
#define VALUE_CMD_RANDOM		5
#define VALUE_CMD_ADD			6
#define VALUE_CMD_SUB			7
#define VALUE_CMD_MUL			8
#define VALUE_CMD_DIV			9
#define VALUE_CMD_COUNT			10
#define VALUE_CMD_COUNTCHILDREN	11
#define VALUE_CMD_MAKE_VARIABLE	14

#define VALUE_CMD_CONCATENATE	12
#define VALUE_CMD_REMOVE_SUBSTRING	13

#define VALUE_CMD_KEYPRESS_ASCII	15
#define VALUE_CMD_KEYPRESS_KEY		4
#define VALUE_CMD_KEYPRESS_NAME		22

#define VALUE_CMD_SAMPLE		16

#define VALUE_CMD_GETNPLAYERS	17
#define VALUE_CMD_GETPLAYERNAME	18
#define VALUE_CMD_GETPLAYERTYPE	19
#define VALUE_CMD_GET_FOCUSING	20

#define VALUE_CMD_NEW_VIEWPORT	21

#define VALUE_CMD_ITOA			23
#define VALUE_CMD_ATOI			24

#define VALUE_CMD_DOT			25
#define VALUE_CMD_ABS			26

#define VALUE_CMD_NEWPLAYER		27

#define VALUE_CMD_GET_NFOCUSING	28

#define VALUE_CMD_DISTANCE		29

#define VALUE_MAX_CMD			30


#define VALUE_VAR_NONE		-1
#define VALUE_VAR_OBJECT	0
#define VALUE_VAR_ROOM		1
#define VALUE_VAR_MAP		2
#define VALUE_VAR_GAME		3
#define VALUE_VAR_INTERFACE	5
#define VALUE_VAR_FOREIGN	4
#define VALUE_VAR_APPLICATION	6
#define VALUE_VAR_DOT		7




class ValueSCRIPT {
	friend class BViewActionScriptWnd;
	friend class BViewConditionScriptWnd;
	friend class BViewValueScriptWnd;
	friend class GameDebugWindow;
	friend class BScriptDebugWnd;

	friend class ActionSCRIPT;

public:
	ValueSCRIPT(void);
	ValueSCRIPT(ValueSCRIPT &s);
	~ValueSCRIPT(void);

	bool save(FILE *fp);
	bool load(FILE *fp,class MOG2 *game);

	char *generate_string(void);
	int get_command(void) {return command;};
	class SAMPLE *get_sample(void) {return sample;};

	void init(void);
	int cycle(int *ival,char **sval,class ActiveOBJECT **oval,ActiveOBJECT *o,class ActiveROOM *r,class ActiveMAP *m,class ActiveMOG2 *g,class ActiveINTERFACE *interf,class ActiveMOG2Application *app,ActiveOBJECT **foreign_object,int location,class KEYBOARDSTATE **LVK,int n_LVKs);

	void copy_state(ValueSCRIPT *s);
	void simplify(void);

	bool uses_sample(class SAMPLE *s);

private:

	int command;
	int ipar;
	char *spar;
	int vlocation;
	char *vname;
	ValueSCRIPT *vpar[6];
	class ConditionSCRIPT *cond;
	class SAMPLE *sample;

	int dx,dy; /* Size of the printed SCRIPT, for the edit windows.	*/ 
};


#endif

